% modified by RE Luginbuhl for NL... 27-12-2017
% model of nsa data for credit, clifs, housing price, ip and gdp for NL
% experiment with priors
% SJ koopman model with matrices A and B in measurement eq
% restricted: A22, A33, B55 
%
%----------------------------------------------------------------
% 1. Model variables and parameters
%----------------------------------------------------------------

var		bbeta1		$\beta_{1}$,
		bbeta2		$\beta_{2}$,
		bbeta3		$\beta_{3}$,
		bbeta4		$\beta_{4}$,
		bbeta5		$\beta_{5}$,
		mmu1		$\mu_{1}$,
		mmu2		$\mu_{2}$,
		mmu3		$\mu_{3}$,
		mmu4		$\mu_{4}$,
		mmu5		$\mu_{5}$,
		ppsi1		$\psi_{1}$,
%		ppsi2		$\psi_{2}$,
%		ppsi3		$\psi_{3}$,
		ppsi4		$\psi_{4}$,
		ppsi5		$\psi_{5}$,
		ppsist1		$\psi^{*}_{1}$,
%		ppsist2		$\psi^{*}_{2}$,
%		ppsist3		$\psi^{*}_{3}$,
		ppsist4		$\psi^{*}_{4}$,
		ppsist5		$\psi^{*}_{5}$,
		ppsi1b		$\gamma_{1}$,
		ppsi2b		$\gamma_{2}$,
		ppsi3b		$\gamma_{3}$,
		ppsi4b		$\gamma_{4}$,
%		ppsi5b		$\gamma_{5}$,
		ppsist1b	$\gamma^{*}_{1}$,
		ppsist2b	$\gamma^{*}_{2}$,
		ppsist3b	$\gamma^{*}_{3}$,
		ppsist4b	$\gamma^{*}_{4}$,
%		ppsist5b	$\gamma^{*}_{5}$,
        seas11      $sal_{1}$,
        seasst11    $sa1^{*}_{1}$,
        seas12      $sas_{1}$,
        %seasst12    $sas^{*}_{1}$,
        seas51      $sal_{5}$,
        seasst51    $sa1^{*}_{5}$,
        seas52      $sas_{5}$,
        %seasst52    $sas^{*}_{5}$,
        seas31      $sal_{3}$,
        seasst31    $sa1^{*}_{3}$,
        seas32      $sas_{3}$,
        %seasst32    $sas^{*}_{3}$,
        seas41      $sal_{4}$,
        seasst41    $sa1^{*}_{4}$,
        seas42      $sas_{4}$,
        seasst42    $sas^{*}_{4}$,
        seas43      $sa3_{4}$,
        seasst43    $sa3^{*}_{4}$,
        seas44      $sa4_{4}$,
        seasst44    $sa4^{*}_{4}$,
        seas45      $sa5_{4}$,
        seasst45    $sa5^{*}_{4}$,
        seas46      $sa6_{4}$,
        seas21      $sal_{2}$,
        seasst21    $sa1^{*}_{2}$,
        seas22      $sas_{2}$,
        seasst22    $sas^{*}_{2}$,
        seas23      $sa3_{2}$,
        seasst23    $sa3^{*}_{2}$,
        seas24      $sa4_{2}$,
        seasst24    $sa4^{*}_{2}$,
        seas25      $sa5_{2}$,
        seasst25    $sa5^{*}_{2}$,
        seas26      $sa6_{2}$,
		cyc1,
		cyc2,
		cyc3,
        cyc4,
        cyc5,
        cyc1b, cyc2b, cyc3b, cyc4b, cyc5b,
		ly		$Y$,
		lc		$C$,
		lp		$P$,
        li      $I$,
        lx      $X$;

varexo		e_irr1		$\epsilon_{1}$,
		e_irr2		$\epsilon_{2}$,
		e_irr3		$\epsilon_{3}$,
		e_irr4		$\epsilon_{4}$,
		e_irr5		$\epsilon_{5}$,
		e_lev1		$\eta_{1}$,
		e_lev2		$\eta_{2}$,
		e_lev3		$\eta_{3}$,
		e_lev4		$\eta_{4}$,
		e_lev5		$\eta_{5}$,
		e_slp1		$\zeta_{1}$,
		e_slp2		$\zeta_{2}$,
		e_slp3		$\zeta_{3}$,
		e_slp4		$\zeta_{4}$,
		e_slp5		$\zeta_{5}$,
		e_cyc1		$\kappa_{1}$,
%		e_cyc2		$\kappa_{2}$,
%		e_cyc3		$\kappa_{3}$,
        e_cyc4      $\kappa_{4}$,
        e_cyc5      $\kappa_{5}$,
		e_cycst1	$\kappa^{*}_{1}$,
%		e_cycst2	$\kappa^{*}_{2}$,
%		e_cycst3	$\kappa^{*}_{3}$,
		e_cycst4	$\kappa^{*}_{4}$,
		e_cycst5	$\kappa^{*}_{5}$,
		e_cyc1b		$\kappa_{b1}$,
		e_cyc2b		$\kappa_{b2}$,
		e_cyc3b		$\kappa_{b3}$,
		e_cyc4b		$\kappa_{b4}$,
%		e_cyc5b		$\kappa_{b5}$,
		e_cycst1b	$\kappa^{*}_{b1}$,
		e_cycst2b	$\kappa^{*}_{b2}$,
		e_cycst3b	$\kappa^{*}_{b3}$,
		e_cycst4b	$\kappa^{*}_{b4}$,
%		e_cycst5b	$\kappa^{*}_{b5}$,
        e_seas11    $esal_{1}$,
        e_seasst11  $esa1^{*}_{1}$,
        e_seas12    $esas_{1}$,
        %e_seasst12  $esas^{*}_{1}$,
        e_seas51    $esal_{5}$,
        e_seasst51  $esa1^{*}_{5}$,
        e_seas52    $esas_{5}$,
        %e_seasst52  $esas^{*}_{5}$,
        e_seas31    $esal_{3}$,
        e_seasst31  $esa1^{*}_{3}$,
        e_seas32    $esas_{3}$,
        %e_seasst32  $esas^{*}_{3}$,
        e_seas41    $esal_{4}$,
        e_seasst41  $esa1^{*}_{4}$,
        e_seas42    $esas_{4}$,
        e_seasst42  $esas^{*}_{4}$,
        e_seas43    $esa3_{4}$,
        e_seasst43  $esa3^{*}_{4}$,
        e_seas44    $esa4_{4}$,
        e_seasst44  $esa4^{*}_{4}$,
        e_seas45    $esa5_{4}$,
        e_seasst45  $esa5^{*}_{4}$,
        e_seas46    $esa6_{4}$,
        e_seas21    $esal_{2}$,
        e_seasst21  $esa1^{*}_{2}$,
        e_seas22    $esas_{2}$,
        e_seasst22  $esas^{*}_{2}$,
        e_seas23    $esa3_{2}$,
        e_seasst23  $esa3^{*}_{2}$,
        e_seas24    $esa4_{2}$,
        e_seasst24  $esa4^{*}_{2}$,
        e_seas25    $esa5_{2}$,
        e_seasst25  $esa5^{*}_{2}$,
        e_seas26    $esa6_{2}$;

parameters	
        rrho1		$\rho_11$,
%        rrho12		$\rho_12$,
%        rrho13		$\rho_13$,
%        rrho14		$\rho_14$,
%        rrho21       $\rho_21$,
        rrho2       $\rho_22$,
%        rrho23       $\rho_23$,
%        rrho24       $\rho_24$,
%		pphi1		$\phi_1$,
		llambda1	$\lambda_11$,
        llambda2   $\lambda_21$,
%		llambda12	$\lambda_12$,
%        llambda22   $\lambda_22$,
%		llambda13	$\lambda_13$,
%        llambda23   $\lambda_23$,
%		llambda14	$\lambda_14$,
%        llambda24   $\lambda_24$,
%        signoise,
%        sigeps1, sigeps2, sigeps3, sigeps4,
        sigma1, sigma4, sigma5,% sigma2, sigma3,
        sigma1b, sigma2b, sigma3b, sigma4b,% sigma5b,
        %sigma1b, sigma2b, sigma3b, 
        seassig11,% seassig12,
        seassig21,% seassig22, 
        seassig31,% seassig32,
        seassig41, seassig51,
 %       corseas121, corseas122, corseas131, corseas132, corseas231, corseas232,
 %       corrslp12, corrslp13, corrslp23, corrslp14, corrslp24, corrslp34,
        cycb12, cycb13, cycb23, cycb14, cycb15 cycb24, cycb25, cycb34, cycb35, cycb45,
        cyc13, cyc14, cyc15, cyc12, cyc45;% cyc34, cyc23, cyc24, cyc25, cyc35,


%----------------------------------------------------------------
% 2. Calibration
%----------------------------------------------------------------

%rrho11		= 0.7500;
%rrho12		= 0.7500;
%rrho13		= 0.7500;
%rrho14		= 0.7500;
%rrho21       = 0.7500;
%rrho22       = 0.7500;
%rrho23       = 0.7500;
%rrho24       = 0.7500;
%pphi1		= 0.7500;
%llambda11	= 0.0200;
%llambda12	= 0.0200;
%llambda13	= 0.0200;
%llambda14	= 0.0200;
%llambda21    = 0.0800;
%llambda22    = 0.0800;
%llambda23    = 0.0800;
%llambda24    = 0.0800;
%sigma1      = 0.3;
%sigma2      = 0.3;
%sigma3      = 0.3;
%sigma1b      = 0.3;
%sigma2b      = 0.3;
%sigma3b      = 0.3;
%cycb12       = 0.0;
%cycb13       = 0.0;
%cycb23       = 0.0;
%cycb14       = 0.0;
%cycb24       = 0.0;
%cycb34       = 0.0;
%cyc12       = 0.0;
%cyc13       = 0.0;
%cyc23       = 0.0;
%cyc14       = 0.0;
%cyc24       = 0.0;

%----------------------------------------------------------------
% 3. Model
%----------------------------------------------------------------

model(linear);


%%%%% STOCHASTIC TRENDS AND SLOPES %%%%%

mmu1 		=    mmu1(-1)	 + bbeta1(-1)   + e_lev1;
bbeta1		=		   bbeta1(-1)	   +    + e_slp1; % + signoise*sigeps1*e_slp1;

mmu2 		=    mmu2(-1)	 + bbeta2(-1)   + e_lev2; %  
bbeta2		=		   bbeta2(-1)           + e_slp2; % + signoise*sigeps2*((1 - corrslp12^2)^0.5*e_slp2 + corrslp12*e_slp1);

mmu3 		=    mmu3(-1)	 + bbeta3(-1)   + e_lev3;
bbeta3		=		   bbeta3(-1)           + e_slp3; % + signoise*sigeps3*((1 - corrslp23^2 - corrslp13^2)^0.5*e_slp3 + corrslp23*e_slp2 + corrslp13*e_slp1);

mmu4 		=    mmu4(-1)	 + bbeta4(-1)   + e_lev4;
bbeta4		=		   bbeta4(-1)           + e_slp4; % + signoise*sigeps4*((1 - corrslp14^2 - corrslp24^2 - corrslp34^2)^0.5*e_slp4 + corrslp34*e_slp3 + corrslp24*e_slp2 + corrslp14*e_slp1);

mmu5 		=    mmu5(-1)	 + bbeta5(-1)   + e_lev5; %   
bbeta5		=		   bbeta5(-1)           + e_slp5;


%%%%% SEASONAL %%%%%%

#rcs1		= cos(acos(-1)/6);
#rss1		= 0.5; % sin(acos(-1)/6);
#rcs2		= 0.5; % cos(acos(-1)/3);
#rss2		= sin(acos(-1)/3);
#rcs3		= 0.0; % cos(acos(-1)/2);
#rss3		= 1.0; % sin(acos(-1)/2);
#rcs4		= -0.5; % cos(2*acos(-1)/3);
#rss4		= sin(2*acos(-1)/3);
#rcs5		= cos(5*acos(-1)/6);
#rss5		= 0.5; % sin(5*acos(-1)/6);
#rcs6		= -1; % cos(acos(-1));

seas11      = rcs1*seas11(-1) 	 + rss1*seasst11(-1)    + seassig11*e_seas11;
seasst11	=-rss1*seas11(-1) 	 + rcs1*seasst11(-1)    + seassig11*e_seasst11;
seas12      = -seas12(-1) 	     + seassig11*e_seas12;
%seasst12	=-rss2*seas12(-1) 	 + rcs2*seasst12(-1)    + seassig11*e_seasst12;

seas21      = rcs1*seas21(-1) 	 + rss1*seasst21(-1)    + seassig21*e_seas21;
seasst21	=-rss1*seas21(-1) 	 + rcs1*seasst21(-1)    + seassig21*e_seasst21;
seas22      = rcs2*seas22(-1) 	 + rss2*seasst22(-1)    + seassig21*e_seas22;
seasst22	=-rss2*seas22(-1) 	 + rcs2*seasst22(-1)    + seassig21*e_seasst22;
seas23      = rcs3*seas23(-1) 	 + rss3*seasst23(-1)    + seassig21*e_seas23;
seasst23	=-rss3*seas23(-1) 	 + rcs3*seasst23(-1)    + seassig21*e_seasst23;
seas24      = rcs4*seas24(-1) 	 + rss4*seasst24(-1)    + seassig21*e_seas24;
seasst24	=-rss4*seas24(-1) 	 + rcs4*seasst24(-1)    + seassig21*e_seasst24;
seas25      = rcs5*seas25(-1) 	 + rss5*seasst25(-1)    + seassig21*e_seas25;
seasst25	=-rss5*seas25(-1) 	 + rcs5*seasst25(-1)    + seassig21*e_seasst25;
seas26    = -seas26(-1)   + seassig21*e_seas26;

seas31      = rcs1*seas31(-1) 	 + rss1*seasst31(-1)    + seassig31*e_seas31;
seasst31	=-rss1*seas31(-1) 	 + rcs1*seasst31(-1)    + seassig31*e_seasst31;
seas32      = -seas32(-1) 	     + seassig31*e_seas32;
%seasst22	=-rss2*seas22(-1) 	 + rcs2*seasst22(-1)    + seassig21*e_seasst22;

seas41      = rcs1*seas41(-1) 	 + rss1*seasst41(-1)    + seassig31*e_seas41;
seasst41	=-rss1*seas41(-1) 	 + rcs1*seasst41(-1)    + seassig31*e_seasst41;
seas42      = rcs2*seas42(-1) 	 + rss2*seasst42(-1)    + seassig31*e_seas42;
seasst42	=-rss2*seas42(-1) 	 + rcs2*seasst42(-1)    + seassig31*e_seasst42;
seas43      = rcs3*seas43(-1) 	 + rss3*seasst43(-1)    + seassig31*e_seas43;
seasst43	=-rss3*seas43(-1) 	 + rcs3*seasst43(-1)    + seassig31*e_seasst43;
seas44      = rcs4*seas44(-1) 	 + rss4*seasst44(-1)    + seassig31*e_seas44;
seasst44	=-rss4*seas44(-1) 	 + rcs4*seasst44(-1)    + seassig31*e_seasst44;
seas45      = rcs5*seas45(-1) 	 + rss5*seasst45(-1)    + seassig31*e_seas45;
seasst45	=-rss5*seas45(-1) 	 + rcs5*seasst45(-1)    + seassig31*e_seasst45;
seas46    = -seas46(-1)   + seassig31*e_seas46;

seas51      = rcs1*seas51(-1) 	 + rss1*seasst51(-1)    + seassig51*e_seas51;
seasst51	=-rss1*seas51(-1) 	 + rcs1*seasst51(-1)    + seassig51*e_seasst51;
seas52      = -seas52(-1) 	     + seassig51*e_seas52;


%%%%% CYCLICAL AUTOREGRESSIONS %%%%%

#rc		= rrho1*cos(2*acos(-1)/llambda1);
#rs		= rrho1*sin(2*acos(-1)/llambda1);

%#rc2		= rrho12*cos(2*acos(-1)/llambda12);
%#rs2		= rrho12*sin(2*acos(-1)/llambda12);

%#rc3		= rrho13*cos(2*acos(-1)/llambda13);
%#rs3		= rrho13*sin(2*acos(-1)/llambda13);

%#rc4		= rrho14*cos(2*acos(-1)/llambda14);
%#rs4		= rrho14*sin(2*acos(-1)/llambda14);

ppsi1		= rc*ppsi1(-1) 	 + rs*ppsist1(-1)   + sigma1*e_cyc1; % + sigma1*e_cyc1;
ppsist1		=-rs*ppsi1(-1) 	 + rc*ppsist1(-1)   + sigma1*e_cycst1;
%car1		=    ppsi1(-1) 	 + pphi1*car1(-1)   + 0;
%carst1		=    ppsist1(-1) + pphi1*carst1(-1) + 0;

%ppsi2		= rc*ppsi2(-1)	 + rs*ppsist2(-1)   +  sigma2*e_cyc2; % + cyc12*e_cyc1; %
%ppsist2		=-rs*ppsi2(-1)	 + rc*ppsist2(-1)   +  sigma2*e_cycst2; % + cyc12*e_cycst1; %
%car2		=    ppsi2(-1)	 + pphi1*car2(-1)   + 0;
%carst2		=    ppsist2(-1) + pphi1*carst2(-1) + 0;

%ppsi3		= rc*ppsi3(-1)	 + rs*ppsist3(-1)   + sigma3*e_cyc3; % + cyc13*e_cyc1; %; %  + cyc23*e_cyc2  
%ppsist3		=-rs*ppsi3(-1)	 + rc*ppsist3(-1)   + sigma3*e_cycst3; % + cyc13*e_cycst1; %  %  + cyc23*e_cycst2
%car3		=    ppsi3(-1)	 + pphi1*car3(-1)   + 0;
%carst3		=    ppsist3(-1) + pphi1*carst3(-1) + 0;

ppsi4		= rc*ppsi4(-1)	 + rs*ppsist4(-1)   + sigma4*e_cyc4; %   + cyc14*e_cyc1;%  + cyc24*e_cyc2 + cyc34*e_cyc3; %;
ppsist4		=-rs*ppsi4(-1)	 + rc*ppsist4(-1)   + sigma4*e_cycst4; % + cyc14*e_cycst1;% + cyc24*e_cycst2 + cyc34*e_cycst3; %;
%car3		=    ppsi3(-1)	 + pphi1*car3(-1)   + 0;
%carst3		=    ppsist3(-1) + pphi1*carst3(-1) + 0;

ppsi5		= rc*ppsi5(-1)	 + rs*ppsist5(-1)   + sigma5*e_cyc5; %   + cyc15*e_cyc1+ cyc45*e_cyc4; %;   + cyc25*e_cyc2 + cyc35*e_cyc3 
ppsist5		=-rs*ppsi5(-1)	 + rc*ppsist5(-1)   + sigma5*e_cycst5; % + cyc15*e_cycst1+ cyc45*e_cycst4; %; + cyc25*e_cycst2 + cyc35*e_cycst3 

% business cycle

#rcb	= rrho2*cos(2*acos(-1)/llambda2);
#rsb	= rrho2*sin(2*acos(-1)/llambda2);

%%#rcb1	= rrho21*cos(llambda21);
%%#rsb1	= rrho21*sin(llambda21);

%#rcb2	= rrho22*cos(2*acos(-1)/llambda22);
%#rsb2	= rrho22*sin(2*acos(-1)/llambda22);

%#rcb3	= rrho23*cos(2*acos(-1)/llambda23);
%#rsb3	= rrho23*sin(2*acos(-1)/llambda23);

%#rcb4	= rrho24*cos(2*acos(-1)/llambda24);
%#rsb4	= rrho24*sin(2*acos(-1)/llambda24);

ppsi1b		= rcb*ppsi1b(-1) + rsb*ppsist1b(-1)   + sigma1b*e_cyc1b;
ppsist1b	=-rsb*ppsi1b(-1) + rcb*ppsist1b(-1)   + sigma1b*e_cycst1b;

ppsi2b		= rcb*ppsi2b(-1) + rsb*ppsist2b(-1)   + sigma2b*e_cyc2b; % + cycb12*e_cyc1b;
ppsist2b	=-rsb*ppsi2b(-1) + rcb*ppsist2b(-1)   + sigma2b*e_cycst2b; % + cycb12*e_cycst1b;

ppsi3b		= rcb*ppsi3b(-1) + rsb*ppsist3b(-1)   + sigma3b*e_cyc3b; % + cycb13*e_cyc1b + cycb23*e_cyc2b;
ppsist3b	=-rsb*ppsi3b(-1) + rcb*ppsist3b(-1)   + sigma3b*e_cycst3b; % + cycb13*e_cycst1b + cycb23*e_cycst2b;

ppsi4b		= rcb*ppsi4b(-1) + rsb*ppsist4b(-1)   + sigma4b*e_cyc4b; % + cycb14*e_cyc1b + cycb24*e_cyc2b  + cycb34*e_cyc3b;
ppsist4b	=-rsb*ppsi4b(-1) + rcb*ppsist4b(-1)   + sigma4b*e_cycst4b; % + cycb14*e_cycst1b + cycb24*e_cycst2b + cycb34*e_cycst3b;

%ppsi5b		= rcb*ppsi5b(-1) + rsb*ppsist5b(-1)   + sigma5b*e_cyc5b; % + cycb15*e_cyc1b   + cycb25*e_cyc2b + cycb35*e_cyc3b + cycb45*e_cyc4b; %;   
%ppsist5b	=-rsb*ppsi5b(-1) + rcb*ppsist5b(-1)   + sigma5b*e_cycst5b; % + cycb15*e_cycst1b + cycb25*e_cycst2b + cycb35*e_cycst3b + cycb45*e_cycst4b; %; 

%%%%% CYCLES %%%%%

cyc1		= ppsi1;
cyc2		= cyc12*ppsi1;
cyc3		= cyc13*ppsi1;
cyc4        = ppsi4 + cyc14*ppsi1;
cyc5        = ppsi5 + cyc15*ppsi1 + cyc45*ppsi4;

cyc1b       = ppsi1b;
cyc2b       = ppsi2b + cycb12*ppsi1b;
cyc3b       = ppsi3b + cycb13*ppsi1b + cycb23*ppsi2b;
cyc4b       = ppsi4b + cycb14*ppsi1b + cycb24*ppsi2b + cycb34*ppsi3b;
cyc5b       =          cycb15*ppsi1b + cycb25*ppsi2b + cycb35*ppsi3b + cycb45*ppsi4b;

%%%%% MEASUREMENT EQUATIONS %%%%%

lc		=     mmu1	+ cyc1 + cyc1b + seas11 + seas12 + e_irr1; % + sigeps1*e_irr1;
lx		=     mmu2	+ cyc2 + cyc2b + seas21 + seas22 + seas23 + seas24 + seas25 + seas26 + e_irr2; % + sigeps3*e_irr3;
lp		=     mmu3	+ cyc3 + cyc3b + seas31 + seas32 + e_irr3; % + sigeps2*e_irr3;
li		=     mmu4	+ cyc4 + cyc4b + seas41 + seas42 + seas43 + seas44 + seas45 + seas46 + e_irr4; % + sigeps3*e_irr3; %
ly		=     mmu5	+ cyc5 + cyc5b + seas51 + seas52 + e_irr5; % + sigeps3*e_irr3;

end;

shocks;

%var e_irr1;     stderr 1.0000;
%var e_irr2;     stderr 1.0000;
%var e_irr3;     stderr 1.0000;
%var e_irr4;     stderr 1.0000;

%var e_slp1;     stderr 1.0000;
%var e_slp2;     stderr 1.0000;
%var e_slp3;     stderr 1.0000;
%var e_slp4;     stderr 1.0000;

var e_cyc1; 	stderr 1.0000;
var e_cycst1;	stderr 1.0000;

var e_cyc1b; 	stderr 1.0000;
var e_cycst1b;	stderr 1.0000;

%var e_cyc2; 	stderr 1.0000;
%var e_cycst2;	stderr 1.0000;

var e_cyc2b; 	stderr 1.0000;
var e_cycst2b;	stderr 1.0000;

%var e_cyc3; 	stderr 1.0000;
%var e_cycst3;	stderr 1.0000;

var e_cyc3b; 	stderr 1.0000;
var e_cycst3b;	stderr 1.0000;

var e_cyc4; 	stderr 1.0000;
var e_cycst4;	stderr 1.0000;

var e_cyc4b; 	stderr 1.0000;
var e_cycst4b;	stderr 1.0000;

var e_cyc5; 	stderr 1.0000;
var e_cycst5;	stderr 1.0000;

%var e_cyc5b; 	stderr 1.0000;
%var e_cycst5b;	stderr 1.0000;

%corr e_cyc1, e_cyc2 = cyc12;
%corr e_cycst1, e_cycst2 = cyc12;
%corr e_cyc1, e_cyc3 = cyc13;
%corr e_cycst1, e_cycst3 = cyc13;
%corr e_cyc2, e_cyc3 = cyc23;
%corr e_cycst2, e_cycst3 = cyc23;

var e_seas11;    stderr 1.0000;
var e_seasst11;  stderr 1.0000;
var e_seas12;   stderr 1.0000;
%var e_seasst12;  stderr 1.0000;
var e_seas21;   stderr 1.0000;
var e_seasst21;  stderr 1.0000;
var e_seas22;   stderr 1.0000;
var e_seasst22;  stderr 1.0000;
var e_seas23;   stderr 1.0000;
var e_seasst23;  stderr 1.0000;
var e_seas24;   stderr 1.0000;
var e_seasst24;  stderr 1.0000;
var e_seas25;   stderr 1.0000;
var e_seasst25;  stderr 1.0000;
var e_seas26;   stderr 1.0000;
var e_seas31;   stderr 1.0000;
var e_seasst31;  stderr 1.0000;
var e_seas32;   stderr 1.0000;
%var e_seasst32;  stderr 1.0000;
var e_seas41;   stderr 1.0000;
var e_seasst41;  stderr 1.0000;
var e_seas42;   stderr 1.0000;
var e_seasst42;  stderr 1.0000;
var e_seas43;   stderr 1.0000;
var e_seasst43;  stderr 1.0000;
var e_seas44;   stderr 1.0000;
var e_seasst44;  stderr 1.0000;
var e_seas45;   stderr 1.0000;
var e_seasst45;  stderr 1.0000;
var e_seas46;   stderr 1.0000;
var e_seas51;   stderr 1.0000;
var e_seasst51;  stderr 1.0000;
var e_seas52;   stderr 1.0000;
%var e_seasst52;  stderr 1.0000;

end;

write_latex_dynamic_model;

%----------------------------------------------------------------
% 4. Estimated parameters and data
%----------------------------------------------------------------

estimated_params;

%%%%% PARAMETERS %%%%%

	rrho1,		beta_pdf,       0.98, 0.01; % 0.7, 0.2;
	rrho2,		beta_pdf,       0.98, 0.01; % 0.7, 0.2;
%	rrho12,		beta_pdf,       0.95, 0.02; % 0.7, 0.2;
%	rrho22,		beta_pdf,       0.95, 0.02; % 0.7, 0.2;
%	rrho13,		beta_pdf,       0.95, 0.02; % 0.7, 0.2;
%	rrho23,		beta_pdf,       0.95, 0.02; % 0.7, 0.2;
%	rrho14,		beta_pdf,       0.95, 0.02; % 0.7, 0.2;
%	rrho24,		beta_pdf,       0.95, 0.02; % 0.7, 0.2;
%	pphi1,		beta_pdf,       0.75, 0.10;
	llambda1,	gamma_pdf,      300, 15; % beta_pdf,     0.01, 0.009;
	llambda2,	gamma_pdf,      120, 10; % beta_pdf,     0.1, 0.05;
%	llambda12,	gamma_pdf,      300, 50; % beta_pdf,     0.01, 0.009;
%	llambda22,	gamma_pdf,      120, 30; % beta_pdf,     0.1, 0.05;
%	llambda13,	gamma_pdf,      300, 50; % beta_pdf,     0.01, 0.009;
%	llambda23,	gamma_pdf,      120, 30; % beta_pdf,     0.1, 0.05;
%	llambda14,	gamma_pdf,      300, 50; % beta_pdf,     0.01, 0.009;
%	llambda24,	gamma_pdf,      120, 30; % beta_pdf,     0.1, 0.05;

%    sigeps1,    inv_gamma_pdf,  0.8, 0.06; % inf;
%    sigeps2,    inv_gamma_pdf,  0.8, 0.06; % inf;
%    sigeps3,    inv_gamma_pdf,  0.8, 0.06; % inf;
%    sigeps4,    inv_gamma_pdf,  0.8, 0.06; % inf;

%    signoise,   beta_pdf,       0.012, 0.006;
%    corrslp12,	beta_pdf,       0, 0.3, -1, 1;
%    corrslp13,	beta_pdf,       0, 0.3, -1, 1;
%    corrslp23,	beta_pdf,       0, 0.3, -1, 1;
%    corrslp14,	beta_pdf,       0, 0.3, -1, 1;
%    corrslp24,	beta_pdf,       0, 0.3, -1, 1;
%    corrslp34,	beta_pdf,       0, 0.3, -1, 1;

    sigma1,     inv_gamma_pdf,  0.2, inf; % 0.4, 0.05; % inf;
%    sigma2,     inv_gamma_pdf,  1.0, inf; %0.1; % inf;
%    sigma3,     inv_gamma_pdf,  0.5, inf; %0.5, 0.05; % inf;
    sigma4,     inv_gamma_pdf,  1.0, inf; %,0.1; % inf;
    sigma5,     inv_gamma_pdf,  0.2, inf; %, 0.05; % inf;

    cyc12,		normal_pdf,     1.5, 5.0; % ,      inv_gamma_pdf,  0.05, inf; % beta_pdf,       0, 0.3, -1, 1;
    cyc13,		normal_pdf,     0.5, 5.0; % ,      inv_gamma_pdf,  0.05, inf; % beta_pdf,       0, 0.3, -1, 1;
    cyc14,		normal_pdf,     0.5, 5.0;
    cyc15,		normal_pdf,     0.5, 5.0;
%    cyc34,		normal_pdf,     0.5, 5.0;
%    cyc35,		normal_pdf,     0.5, 5.0;
    cyc45,		normal_pdf,     0.5, 5.0;
%    cyc25,		normal_pdf,     0.5, 5.0;
%    cyc24,		normal_pdf,     0.5, 5.0;
%    cyc23,      normal_pdf,     0.5, 5.0; %inv_gamma_pdf,  0.005, inf; % beta_pdf,       0, 0.3, -1, 1;

    sigma1b,     inv_gamma_pdf,  0.5, inf; %0.19, 0.05; % inf;
    sigma2b,     inv_gamma_pdf,  2.0, inf; %1.0; % inf;
    sigma3b,     inv_gamma_pdf,  0.5, inf; % 0.88, 0.1; % inf;
    sigma4b,     inv_gamma_pdf,  1.0, inf; %0.96, 0.1; % inf;
%    sigma5b,     inv_gamma_pdf,  0.1, inf; %0.22, 0.05; %inf;

    cycb12,		normal_pdf,     1.50, 5.0; % ,      inv_gamma_pdf,  0.05, inf; % beta_pdf,       0, 0.3, -1, 1;
    cycb13,		normal_pdf,     0.50, 5.0; % ,      inv_gamma_pdf,  0.05, inf; % beta_pdf,       0, 0.3, -1, 1;
    cycb15,		normal_pdf,     0.50, 5.0;
    cycb23,		normal_pdf,     -0.50, 5.0; % ,      inv_gamma_pdf,  0.05, inf; % beta_pdf,       0, 0.3, -1, 1;
    cycb14,		normal_pdf,     0.50, 5.0; % ,      inv_gamma_pdf,  0.05, inf; % beta_pdf,       0, 0.3, -1, 1;
    cycb24,		normal_pdf,     -0.50, 5.0; % ,      inv_gamma_pdf,  0.05, inf; % beta_pdf,       0, 0.3, -1, 1;
    cycb25,		normal_pdf,     -0.50, 5.0;
    cycb34,		normal_pdf,     0.50, 5.0; % ,      inv_gamma_pdf,  0.05, inf; % beta_pdf,       0, 0.3, -1, 1;
    cycb35,		normal_pdf,     0.50, 5.0;
    cycb45,		normal_pdf,     0.50, 5.0;

    seassig11,  inv_gamma_pdf,  0.06, 0.02; % inf;
 %   seassig12,  inv_gamma_pdf,  0.005, inf;
    seassig21,  inv_gamma_pdf,  1.0, inf; % 1.0; %inf;
 %   seassig22,  inv_gamma_pdf,  0.005, inf;
    seassig31,  inv_gamma_pdf,  0.02, 0.005; %inf;
 %   seassig32,  inv_gamma_pdf,  0.005, inf;
    seassig41,  inv_gamma_pdf,  0.0002, inf; % 0.001; %inf;
    seassig51,  inv_gamma_pdf,  0.2, 0.05; % inf;

%    corseas121,      inv_gamma_pdf,  0.005, inf; % beta_pdf,       0, 0.3, -1, 1;
%    corseas122,      inv_gamma_pdf,  0.005, inf; % beta_pdf,       0, 0.3, -1, 1;
%    corseas131,      inv_gamma_pdf,  0.005, inf; % beta_pdf,       0, 0.3, -1, 1;
%    corseas132,      inv_gamma_pdf,  0.005, inf; % beta_pdf,       0, 0.3, -1, 1;
%    corseas231,      inv_gamma_pdf,  0.005, inf; % beta_pdf,       0, 0.3, -1, 1;
%    corseas232,      inv_gamma_pdf,  0.005, inf; % beta_pdf,       0, 0.3, -1, 1;


%%%%% INNOVATIONS %%%%%

stderr	e_irr1,		inv_gamma_pdf,  0.1, inf; % 0.002; % inf;
stderr	e_irr2,		inv_gamma_pdf,  0.0005, inf; % 0.005; % inf;
stderr	e_irr3,		inv_gamma_pdf,  0.0005, inf; % 0.002; % inf;
stderr	e_irr4,		inv_gamma_pdf,  0.005,  inf; % 0.05; % inf;
stderr	e_irr5,		inv_gamma_pdf,  0.0005, inf; % 0.002; % inf;

stderr	e_lev1,		inv_gamma_pdf,  0.02, inf; % 0.005; % inf;
stderr	e_lev2,		inv_gamma_pdf,  0.5, inf; % 0.005; % inf;
stderr	e_lev3,		inv_gamma_pdf,  0.001, inf; %  0.02; % inf; % 0.0001;
stderr	e_lev4,		inv_gamma_pdf,  0.001, inf; % 0.04;
stderr	e_lev5,		inv_gamma_pdf,  0.01, inf; % 0.005;
corr	e_lev1, e_lev2,	uniform_pdf,,,-1,1;
corr	e_lev1, e_lev3,	uniform_pdf,,,-1,1;
corr	e_lev1, e_lev4,	uniform_pdf,,,-1,1;
corr	e_lev1, e_lev5,	uniform_pdf,,,-1,1;
corr	e_lev2, e_lev3,	uniform_pdf,,,-1,1;
corr	e_lev2, e_lev4,	uniform_pdf,,,-1,1;
corr	e_lev2, e_lev5,	uniform_pdf,,,-1,1;
corr	e_lev3, e_lev4,	uniform_pdf,,,-1,1;
corr	e_lev3, e_lev5,	uniform_pdf,,,-1,1;
corr	e_lev4, e_lev5,	uniform_pdf,,,-1,1;

stderr	e_slp1,		inv_gamma_pdf,  0.02, 0.015; %inf;
stderr	e_slp2,		inv_gamma_pdf,  0.05, 0.005; % inf; % 0.015;
stderr	e_slp3,		inv_gamma_pdf,  0.02, 0.015; %inf;
stderr	e_slp4,		inv_gamma_pdf,  0.02, 0.015; %inf;
stderr	e_slp5,		inv_gamma_pdf,  0.02, 0.015; %inf; % 0.015;
corr	e_slp1, e_slp2,	uniform_pdf, 	0.0, 0.5, -1, 1;
corr	e_slp1, e_slp3,	uniform_pdf, 	0.0, 0.5, -1, 1;
corr	e_slp1, e_slp4,	uniform_pdf, 	0.0, 0.5, -1, 1;
corr	e_slp1, e_slp5,	uniform_pdf, 	0.0, 0.5, -1, 1;
corr	e_slp2, e_slp3,	uniform_pdf, 	0.0, 0.5, -1, 1;
corr	e_slp2, e_slp4,	uniform_pdf, 	0.0, 0.5, -1, 1;
corr	e_slp2, e_slp5,	uniform_pdf, 	0.0, 0.5, -1, 1;
corr	e_slp4, e_slp5,	uniform_pdf, 	0.0, 0.5, -1, 1;
corr	e_slp3, e_slp5,	uniform_pdf, 	0.0, 0.5, -1, 1;
corr	e_slp3, e_slp4,	uniform_pdf, 	0.0, 0.5, -1, 1;

%stderr	e_cyc1,		inv_gamma_pdf,  0.5, 0.2; % inf;
%stderr	e_cyc2,		inv_gamma_pdf,  0.5, 0.2;
%stderr	e_cyc3,		inv_gamma_pdf,  0.5, 0.2; % inf;
%stderr	e_cycst1,	inv_gamma_pdf,  0.5, 0.2; % inf;
%stderr	e_cycst2,	inv_gamma_pdf,  0.5, 0.2;
%stderr	e_cycst3,	inv_gamma_pdf,  0.5, 0.2; % inf;
%corr	e_cyc1, e_cyc2,	beta_pdf, 	0.0, 0.3, -1, 1;
%corr	e_cyc1, e_cyc3,	beta_pdf, 	0.0, 0.3, -1, 1;
%corr	e_cyc2, e_cyc3,	beta_pdf, 	0.0, 0.3, -1, 1;

%stderr	e_cyc1b,	inv_gamma_pdf,  0.5, 0.2; % inf;
%stderr	e_cyc2b,	inv_gamma_pdf,  0.5, 0.2;
%stderr	e_cyc3b,	inv_gamma_pdf,  0.5, 0.2; % inf;
%stderr	e_cycst1b,	inv_gamma_pdf,  0.5, 0.2; % inf;
%stderr	e_cycst2b,	inv_gamma_pdf,  0.5, 0.2;
%stderr	e_cycst3b,	inv_gamma_pdf,  0.5, 0.2; % inf;

end;

%
% Observed variables
%

varobs ly, lc, lp, li, lx;	% See NL_data_monthly_5.m for the correspondence between these
			% observables and NL IP, Credit, gdp, clifs and house Prices series


%----------------------------------------------------------------
% 5. Bayesian estimation
%----------------------------------------------------------------

estimation	(
		datafile = NL_data_monthly_5lev,
		nodisplay,
		graph_format = pdf,
%		nodiagnostic,
		diffuse_filter,
		kalman_algo = 0,
        first_obs=1,
		mh_replic = 200,
%        load_mh_file,
%        mh_recover,
		mh_nblocks = 2,
		filtered_vars,
		smoother,
		mode_compute = 0, %6, % 0, %
        mode_file = example_problem_mode,
		plot_priors = 0,
		forecast = 0
		);% mmu1 mmu2 mmu3 mmu4 mmu5 ppsi1 ppsi2 ppsi3 ppsi4 ppsi5 ppsi1b ppsi2b ppsi3b ppsi4b ppsi5b bbeta1 bbeta2 bbeta3 bbeta4 bbeta5 seas11 seas12 seas21 seas22 seas31 seas32 seas41 seas42 seas51 seas52;

